using System.Collections;
using System.Collections.Generic;
using System;

namespace Mahjong
{
    public enum Direction
    {
        East = 1,
        South = 2,
        West = 3,
        North = 4,
    }
    [Serializable]
    public struct GameData
    {
        public Direction Dir_game, Dir_player;
        public bool StartPlayer, Rich, OneBal;
        public int DoraAmount;
        public List<HandType> DoraList;
        public List<HandType> BackdoraList;
        
        public static GameData New()
        {
            GameData result = new GameData();
            result.Dir_game = (Direction) UnityEngine.Random.Range(1, 5);
            result.Dir_player = (Direction)UnityEngine.Random.Range(1, 5);
            result.StartPlayer = result.Dir_player == Direction.East;
            if(Evaluator.Is_Menzen(GameManager.Instance.HandData))
            {
                result.Rich = UnityEngine.Random.Range(0, 100) < 40;
                if (result.Rich)
                    result.OneBal = UnityEngine.Random.Range(0, 100) < 10;
            }
            result.DoraList = new List<HandType>();
            result.BackdoraList = new List<HandType>();
            int gangziAmount = Evaluator.Count_Gangzi_Static(GameManager.Instance.HandData);
            if (gangziAmount < 4)
                result.DoraAmount = UnityEngine.Random.Range(gangziAmount + 1, 5);
            else
                result.DoraAmount = 5;
           
            for(int i=0; i<result.DoraAmount; i++)
            {
                bool succeed = false;
                while(!succeed)
                {
                    var hand = HandGenerator.GetRandomHand();
                    if(GameManager.Instance.HandGenerator.used[(int)hand] <= 3)
                    {
                        result.DoraList.Add(hand);
                        GameManager.Instance.HandGenerator.used[(int)hand] += 1;
                        succeed = true;
                    }
                }
                if (result.Rich)
                {
                    succeed = false;
                    while (!succeed)
                    {
                        var hand = HandGenerator.GetRandomHand();
                        if (GameManager.Instance.HandGenerator.used[(int)hand] <= 3)
                        {
                            result.BackdoraList.Add(hand);
                            GameManager.Instance.HandGenerator.used[(int)hand] += 1;
                            succeed = true;
                        }
                    }
                }
            }
            return result;
        }
        
    }
}
