using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace Mahjong
{
    [Serializable]
    public struct HandSpritePair
    {
        public HandType Hand;
        public Sprite Sprite;
    }

    [CreateAssetMenu(fileName = "MahjongSpriteTable", menuName = "Mahjong/SpriteTable")]
    public class HandSpriteTable : ScriptableObject
    {
        [SerializeField] private List<HandSpritePair> pairList;
        
        public Sprite GetSpriteof(HandType hand)
        {
            foreach(var pair in pairList)
            {
                if (pair.Hand == hand)
                    return pair.Sprite;
            }
            return null;
        }
    }
}