using System.Collections;
using System.Collections.Generic;
using TMPro;
using UnityEngine;
using System;

namespace Mahjong
{
    [Serializable]
    public struct WrongAnswer
    {
        public HandData hand;
        public GameData game;
        public EvaluateData answer;
        public static WrongAnswer By(HandData hand, GameData game, EvaluateData answer)
        {
            var result = new WrongAnswer();
            result.hand = hand;
            result.game = game;
            result.answer = answer;
            return result;
        }
    }
    public class Statistics : MonoBehaviour
    {
        public int currentProblem, correctAnswer, maxAnswer, reviewIndex;
        public float solvingTime;
        public List<WrongAnswer> wrongAnswerList;
        [SerializeField] private TMP_Text problemText, answerText, timeText;

        public void Reset()
        {
            currentProblem = 0;
            correctAnswer = 0;
            maxAnswer = 0;
            solvingTime = 0;
            wrongAnswerList = new List<WrongAnswer>();
            UpdateText();
        }

        public void UpdateText()
        {
            problemText.text = $"  : {currentProblem} / {GameManager.Instance.MaxProblem}";
            answerText.text = $"  : {correctAnswer} / {maxAnswer}";
            timeText.text = $"{(int)solvingTime / 60} {(int)solvingTime % 60}";
        }

        public void UpdateTime()
        {
            solvingTime += Time.deltaTime;
            timeText.text = $"{(int)solvingTime / 60} {(int)solvingTime % 60}";
        }
    }
}
